Disable post-merge jobs
[releng.git] / jjb / fuel / fuel-deploy.sh
index b617bcf..dd89447 100755 (executable)
@@ -1,50 +1,89 @@
 #!/bin/bash
-set -o errexit
+# SPDX-license-identifier: Apache-2.0
+##############################################################################
+# Copyright (c) 2018 Ericsson AB, Mirantis Inc., Enea Software AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
 set -o nounset
 set -o pipefail
 
-# source the file so we get OPNFV vars
-source latest.properties
+export TERM="vt220"
 
-# echo the info about artifact that is used during the deployment
-echo "Using $(echo $OPNFV_ARTIFACT_URL | cut -d'/' -f3) for deployment"
+# set deployment parameters
+export TMPDIR=${HOME}/tmpdir
+# shellcheck disable=SC2153
+LAB_NAME=${NODE_NAME/-*}
+# shellcheck disable=SC2153
+POD_NAME=${NODE_NAME/*-}
 
-# create TMPDIR if it doesn't exist
-export TMPDIR=$HOME/tmpdir
-[[ -d $TMPDIR ]] || mkdir -p $TMPDIR
+# Fuel currently supports arm, enea, ericsson, intel, lf, unh, zte and itri labs
+if [[ ! "${LAB_NAME}" =~ (arm|enea|ericsson|intel|lf|unh|zte|itri) ]]; then
+    echo "Unsupported/unidentified lab ${LAB_NAME}. Cannot continue!"
+    exit 1
+fi
 
-# change permissions down to TMPDIR
-chmod a+x $HOME
-chmod a+x $TMPDIR
+echo "Using configuration for ${LAB_NAME}"
 
-# set CONFDIR, BRIDGE
-CONFDIR=$WORKSPACE/deploy/templates/hardware_environment/conf/linux_foundation_lab/pod2
-BRIDGE=pxebr
+# create TMPDIR if it doesn't exist, change permissions
+mkdir -p "${TMPDIR}"
+sudo chmod a+x "${HOME}" "${TMPDIR}"
 
-# clone genesis repo and checkout the SR1 tag
-echo "Cloning genesis repo"
-cd $WORKSPACE
-GIT_SSL_NO_VERIFY=true git clone https://gerrit.opnfv.org/gerrit/genesis genesis
-cd genesis
-git checkout arno.2015.2.0
+cd "${WORKSPACE}" || exit 1
 
-# cleanup first
-sudo $WORKSPACE/genesis/common/ci/clean.sh -base_config $WORKSPACE/genesis/foreman/ci/inventory/lf_pod2_ksgen_settings.yml
+# log file name
+FUEL_LOG_FILENAME="${JOB_NAME}_${BUILD_NUMBER}.log.tar.gz"
 
-# prepare for Fuel Deployment
-sudo $WORKSPACE/genesis/common/ci/setup.sh
+# Limited scope for vPOD verify jobs running on armband-virtual
+[[ ! "${JOB_NAME}" =~ verify-deploy-virtual-arm64 ]] || EXTRA_ARGS='-e'
+
+# turn on DEBUG mode
+[[ ${CI_DEBUG,,} == true ]] && EXTRA_ARGS="-D ${EXTRA_ARGS:-}"
+
+# construct the command
+DEPLOY_COMMAND="${WORKSPACE}/ci/deploy.sh \
+    -l ${LAB_NAME} -p ${POD_NAME} -s ${DEPLOY_SCENARIO} \
+    -S ${TMPDIR} ${EXTRA_ARGS:-} \
+    -L ${WORKSPACE}/${FUEL_LOG_FILENAME}"
 
 # log info to console
-echo "Starting the deployment using $INSTALLER. This could take some time..."
+echo "Deployment parameters"
+echo "--------------------------------------------------------"
+echo "Scenario: ${DEPLOY_SCENARIO}"
+echo "Lab: ${LAB_NAME}"
+echo "POD: ${POD_NAME}"
+echo
+echo "Starting the deployment using ${INSTALLER_TYPE}. This could take some time..."
 echo "--------------------------------------------------------"
 echo
 
 # start the deployment
 echo "Issuing command"
-echo "sudo $WORKSPACE/ci/deploy.sh -iso $WORKSPACE/opnfv.iso -dea $CONFDIR/dea.yaml -dha $CONFDIR/dha.yaml -s $TMPDIR -b $BRIDGE -nh"
+echo "${DEPLOY_COMMAND}"
+echo
 
-sudo $WORKSPACE/ci/deploy.sh -iso $WORKSPACE/opnfv.iso -dea $CONFDIR/dea.yaml -dha $CONFDIR/dha.yaml -s $TMPDIR -b $BRIDGE -nh
+${DEPLOY_COMMAND}
+exit_code=$?
 
 echo
 echo "--------------------------------------------------------"
-echo "Done!"
+echo "Deployment is done!"
+
+# upload logs for baremetal deployments
+# work with virtual deployments is still going on, so skip that for now
+if [[ "${JOB_NAME}" =~ baremetal-daily ]]; then
+    echo "Uploading deployment logs"
+    gsutil cp "${WORKSPACE}/${FUEL_LOG_FILENAME}" \
+        "gs://${GS_URL}/logs/${FUEL_LOG_FILENAME}" > /dev/null 2>&1
+    echo "Logs are available at http://${GS_URL}/logs/${FUEL_LOG_FILENAME}"
+fi
+
+if [[ "${exit_code}" -ne 0 ]]; then
+    echo "Deployment failed!"
+    exit "${exit_code}"
+fi
+
+echo "Deployment is successful!"
+exit 0